//----------------------------------------------------------------------
//      GCC-специфічні макроси (незалежні від архітектури)

#ifndef GCC_MACROS_H
#define GCC_MACROS_H

//----------------------------------------------------------------------
//      часто використовувані атрибути

#ifndef NOINLINE
#define NOINLINE __attribute__((__noinline__))
#endif

#ifndef FORCE_INLINE
#define FORCE_INLINE __attribute__((__always_inline__))
#endif

#ifndef INLINE
#define INLINE  FORCE_INLINE inline
#endif

#ifndef NORETURN
#define NORETURN __attribute__((__noreturn__))
#endif

#ifndef PACKED
#define PACKED __attribute__((__packed__))
#endif

#ifndef PURE
#define PURE __attribute__((__pure__))
#endif

// conditionals hints
#define LIKELY(x) __builtin_expect((x), true)
#define UNLIKELY(x) __builtin_expect((x), false)

//----------------------------------------------------------------------
//      Не специфічно-gcc, але часто потрібне

#ifndef CONCAT
# define _CONCAT(a,b) a##b
# define CONCAT(a,b) _CONCAT(a,b)
#endif // CONCAT

#ifndef CONCAT3
# define _CONCAT3(a,b,c) a##b##c
# define CONCAT3(a,b,c) _CONCAT(a,b,c)
#endif // CONCAT3

#ifndef STRINGFY
# define _STRINGFY(a) #a
# define STRINGFY(a) _STRINGFY(a)
#endif

#define UNUSED(a) (void)a

#endif // GCC_MACROS_H

/*------        end of file  gcc_macros.h        ------*/
